#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>


int lineNum(char* dictionaryName, char* word, int length){
	int fd = open(dictionaryName, O_RDONLY);
	if(fd < 0) return errno;

	//Ensure the length of the given word matches the 
	//length of the words in the dictionary
	char* spacedOut = malloc(length * sizeof(char));
	int i = 0;
	for(; i < length && word[i] != '\0'; i++){
		spacedOut[i] = word[i];
	}
	for(; i < length-1; i++) spacedOut[i] = ' ';
	spacedOut[length-1] = '\0';
	
	int fileLength = lseek(fd, 0, SEEK_END);
	lseek(fd, 0, SEEK_SET);
	
	char* buffer = malloc(length * sizeof(char));
	buffer[length-1] = '\0';

	//Binary search for the word
	int lineMin = -1;
	int lineMax = (fileLength / length);
	while(1){
		int dif = lineMax-lineMin;
		int output = (lineMin+(dif/2));
		lseek(fd, length*output, SEEK_SET);
		read(fd, buffer, length-1);

		int compare = strcmp(spacedOut, buffer);
		if(compare > 0) lineMin += dif/2;
		if(compare < 0)	lineMax = output;
		if(compare == 0){
			close(fd);
			free(buffer);
			free(spacedOut);
			return output+1;
		}

		if((lineMax - lineMin) <= 1){
			close(fd);
			free(buffer);
			free(spacedOut);
			return -(output+1);
		}
	}
}